Bug 94778

Summary: [EFL] Drop default theme concept
Product: WebKit Reporter: Ryuan Choi <ryuan.choi>
Component: WebKit EFLAssignee: Ryuan Choi <ryuan.choi>
Status: RESOLVED FIXED    
Severity: Normal CC: dglazkov, d-r, gyuyoung.kim, leandro, lucas.de.marchi, rakuco, webkit.review.bot
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Bug Depends on:    
Bug Blocks: 94670    
Attachments:
Description Flags
Patch
none
Patch none

Description Ryuan Choi 2012-08-22 22:39:39 PDT
As discussed on Bug 94670 and IRC(#webkit-efl),

Efl port provides default.edj and it can be used as a default theme for applications.
But, webkit1/efl does not provide a way for applications to know the location of it.
And webkit2/efl sets it as a default (Bug 90107), so that WebCore always try to access default theme although applications want to change theme.

In order to fix addressed issues,
first suggestion is leaving it up to the user to call ewk_view_theme_set() and providing a path of default.edj in a PC file.
Comment 1 Raphael Kubo da Costa (:rakuco) 2012-08-23 09:02:21 PDT
We already provide a `datadir' variable in ewebkit.pc, so it's just a matter of calling `pkg-config --variable=datadir ewebkit' in an application's configure.ac or whatever to get the path to the default theme.
Comment 2 Ryuan Choi 2012-08-23 09:15:23 PDT
(In reply to comment #1)
> We already provide a `datadir' variable in ewebkit.pc, so it's just a matter of calling `pkg-config --variable=datadir ewebkit' in an application's configure.ac or whatever to get the path to the default theme.

Yes, we provide datadir. but I think that we need to provide a path including name('default.edj') or just name.
Comment 3 Raphael Kubo da Costa (:rakuco) 2012-08-23 09:29:37 PDT
I don't find it necessary; people[1] already make do with what's provided. People shouldn't need to worry much about the default theme anyway -- as we briefly discussed yesterday (I don't remember if on the bug or on IRC), if we set the default theme by default most people won't ever need to use it again.

[1] http://trac.enlightenment.org/e/browser/trunk/elementary/src/lib/elm_web.c#L128
Comment 4 Ryuan Choi 2012-09-02 19:35:17 PDT
(In reply to comment #3)
> I don't find it necessary; people[1] already make do with what's provided. People shouldn't need to worry much about the default theme anyway -- as we briefly discussed yesterday (I don't remember if on the bug or on IRC), if we set the default theme by default most people won't ever need to use it again.
> 
> [1] http://trac.enlightenment.org/e/browser/trunk/elementary/src/lib/elm_web.c#L128

OK if then, do you want to just drop default theme concept from webkit2/efl ?

When I implemented theme API for webkit2/efl, I accepted drott's suggestion because default theme looks reasonable (I thought that almost applications may use default theme).

But now, I think that we'd better to remove default theme because WebCore always access default.edj although user change theme path.
Comment 5 Raphael Kubo da Costa (:rakuco) 2012-09-03 04:05:53 PDT
(In reply to comment #4)
> OK if then, do you want to just drop default theme concept from webkit2/efl ?

Yes -- ewk1 and ewk2 could just set the default theme on initialization and after that it should not be able to differentiate between the themes passed to it.

Dominik, does that make sense to you?
Comment 6 Ryuan Choi 2012-09-03 06:37:38 PDT
Created attachment 161918 [details]
Patch
Comment 7 WebKit Review Bot 2012-09-03 06:41:46 PDT
Comment on attachment 161918 [details]
Patch

Attachment 161918 [details] did not pass chromium-ews (chromium-xvfb):
Output: http://queues.webkit.org/results/13733555
Comment 8 Ryuan Choi 2012-09-03 17:45:13 PDT
Created attachment 161952 [details]
Patch
Comment 9 Dominik Röttsches (drott) 2012-09-04 01:12:14 PDT
(In reply to comment #5)
> (In reply to comment #4)
> > OK if then, do you want to just drop default theme concept from webkit2/efl ?
> 
> Yes -- ewk1 and ewk2 could just set the default theme on initialization and after that it should not be able to differentiate between the themes passed to it.
> 
> Dominik, does that make sense to you?

Makes sense to me, seemed overly complicated from the beginning.
Comment 10 WebKit Review Bot 2012-09-04 01:27:02 PDT
Comment on attachment 161952 [details]
Patch

Clearing flags on attachment: 161952

Committed r127444: <http://trac.webkit.org/changeset/127444>
Comment 11 WebKit Review Bot 2012-09-04 01:27:06 PDT
All reviewed patches have been landed.  Closing bug.